module StageableController
  extend ActiveSupport::Concern

  included do
    before_action :authenticate_user!, only: [:add_stages, :remove_stages]
  end

    # POST /v1/learning_objects/1/educational_stages
    # POST /v1/learning_objects/1/educational_stages.json
    def add_stages
      stageable.add_educational_stages(ids: params[:educational_stages])
      render json: stageable.educational_stages, status: :created
    end

    # DELETE /v1/learning_objects/1/educational_stages
    # DELETE /v1/learning_objects/1/educational_stages.json
    def remove_stages
      stageable.remove_educational_stages(ids: params[:educational_stages])
      render json: stageable.educational_stages, status: :ok
    end

    protected

    def stageable
      raise NotImplementedError
    end

end
